
#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
#endregion

namespace BouncingBall
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        ContentManager content;

        //this is a texture we can render
        Texture2D myTexture;

        //coordinates to draw the sprite at
        double spriteX = 0;
        double spriteY = 0;
        double gravityAccel = 3.0;
        double frictionDecelY = 1.003;
        double frictionDecelX = 1.0075;

        //store some info about the sprite's motion
        double m_dSpriteHorizSpeed = 10.0;
        double m_dSpriteVertSpeed = -2.0;

        //this is the object that will draw the sprites
        SpriteBatch spriteBatch;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            content = new ContentManager(Services);
        }


        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }


        /// <summary>
        /// Load your graphics content.  If loadAllContent is true, you should
        /// load content from both ResourceManagementMode pools.  Otherwise, just
        /// load ResourceManagementMode.Manual content.
        /// </summary>
        /// <param name="loadAllContent">Which type of content to load.</param>
        protected override void LoadGraphicsContent(bool loadAllContent)
        {
            if (loadAllContent)
            {
                myTexture = Texture2D.FromFile(graphics.GraphicsDevice, "GreenSmall.png");
                spriteBatch = new SpriteBatch(graphics.GraphicsDevice);
            }

            // TODO: Load any ResourceManagementMode.Manual content
        }


        /// <summary>
        /// Unload your graphics content.  If unloadAllContent is true, you should
        /// unload content from both ResourceManagementMode pools.  Otherwise, just
        /// unload ResourceManagementMode.Manual content.  Manual content will get
        /// Disposed by the GraphicsDevice during a Reset.
        /// </summary>
        /// <param name="unloadAllContent">Which type of content to unload.</param>
        protected override void UnloadGraphicsContent(bool unloadAllContent)
        {
            if (unloadAllContent == true)
            {
                content.Unload();
            }
        }


        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the default game to exit on Xbox 360 and Windows
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your game logic here
            //move the sprite around
            UpdateSprite();

            // Let the GameComponents update
            //UpdateComponents();

            base.Update(gameTime);
        }


        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            //origi
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);

            spriteBatch.Begin(SpriteBlendMode.AlphaBlend);
            spriteBatch.Draw(myTexture, new Rectangle((int)spriteX, (int)spriteY,
                myTexture.Width, myTexture.Height), Color.White);
            spriteBatch.End();

            //orig
            base.Draw(gameTime);
        }

        void UpdateSprite()
        {
            //move the sprite by speed
            spriteX += m_dSpriteHorizSpeed;
            spriteY += m_dSpriteVertSpeed;

            double MaxX = Window.ClientBounds.Width - myTexture.Width;
            double MinX = 0.0;
            double MaxY = Window.ClientBounds.Height - myTexture.Height;
            double MinY = 0.0;

            //check for bounce
            if (spriteX >= MaxX)
            {
                m_dSpriteHorizSpeed = -m_dSpriteHorizSpeed;
                spriteX = MaxX;
            }
            else if (spriteX <= MinX)
            {
                m_dSpriteHorizSpeed = -m_dSpriteHorizSpeed;
                spriteX = MinX;
            }

            if (spriteY >= MaxY)
            {
                m_dSpriteVertSpeed = -m_dSpriteVertSpeed;
                spriteY = MaxY;
            }
            else if (spriteY <= MinY)
            {
                m_dSpriteVertSpeed = -m_dSpriteVertSpeed;
                spriteY = MinY;
            }

            m_dSpriteVertSpeed += gravityAccel - 1.0;
            m_dSpriteVertSpeed /= frictionDecelY;
            m_dSpriteHorizSpeed /= frictionDecelX;
        }
    }
}